org.icefaces.ace.component.dataexporter

## Class Exporter

- java.lang.Object
- - org.icefaces.ace.component.dataexporter.Exporter

- Direct Known Subclasses:
    CSVExporter, ExcelExporter, PDFExporter, XMLExporter

      public abstract class Exporter
      extends java.lang.Object

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected static class` | `Exporter.ColumnType`
    `protected static class` | `Exporter.SpanningColumn`
    `protected static class` | `Exporter.SpanningRow`
    `protected class` | `Exporter.SpanningRows`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected java.lang.String` | `encodingType`
    `protected int[]` | `excludeColumns`
    `protected boolean` | `expandedOnly`
    `protected java.lang.String` | `filename`
    `protected static java.util.regex.Pattern` | `HTML_TAG_PATTERN`
    `protected boolean` | `includeFooters`
    `protected boolean` | `includeHeaders`
    `protected static java.util.logging.Logger` | `logger`
    `protected boolean` | `pageOnly`
    `protected java.lang.String` | `pdfFont`
    `protected javax.el.MethodExpression` | `postProcessor`
    `protected javax.el.MethodExpression` | `preProcessor`
    `protected boolean` | `selectedRowsOnly`
    `protected Exporter.SpanningRows` | `spanningFooterRows`
    `protected Exporter.SpanningRows` | `spanningRows`
    `protected boolean` | `userColumnOrder`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Exporter()`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `determineHeaderColumnOrdering(java.util.List<Row> rows, DataTable table)`
    `abstract java.lang.String` | `export(javax.faces.context.FacesContext facesContext, DataExporter component, DataTable table)`
    `protected void` | `exportChildRowValues(javax.faces.context.FacesContext context, TreeDataModel rootModel, RowStateMap rowStateMap, DataTable table, java.lang.String rootIndex, java.lang.StringBuilder builder)`
    `protected void` | `exportConditionalRowValues(java.lang.StringBuilder builder, Row row)`
    `protected java.lang.String` | `exportValue(javax.faces.context.FacesContext context, javax.faces.component.UIComponent component)`
    `protected ColumnGroup` | `getColumnGroupFooter(javax.faces.component.UIData table)`
    `protected ColumnGroup` | `getColumnGroupHeader(javax.faces.component.UIData table)`
    `protected java.util.List<javax.faces.component.UIColumn>` | `getColumnsToExport(javax.faces.component.UIData table, int[] excludedColumns)`
    `protected java.util.List<javax.faces.component.UIColumn>` | `getFooterRowColumnsToExport(Row row, javax.faces.component.UIData table, int[] excludedColumns)`
    `protected java.util.List<javax.faces.component.UIColumn>` | `getRowColumnsToExport(Row row, javax.faces.component.UIData table, int[] excludedColumns)`
    `protected java.util.List<Row>` | `getRows(ColumnGroup columnGroup)`
    `protected java.util.List<Row>` | `getRows(ColumnGroup columnGroup, boolean includeAll)`
    `protected boolean` | `hasColumnFooter(java.util.List<javax.faces.component.UIColumn> columns)`
    `protected java.lang.String` | `registerResource(byte[] bytes, java.lang.String filename, java.lang.String contentType)`
    `protected int[]` | `resolveExcludedColumnIndexes(java.lang.String columnsToExclude)`
    `void` | `setUp(DataExporter component, DataTable table)`
    `protected boolean` | `shouldExcludeFromExport(javax.faces.component.UIComponent component)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### logger

          protected static final java.util.logging.Logger logger

    - #### HTML_TAG_PATTERN

          protected static final java.util.regex.Pattern HTML_TAG_PATTERN

    - #### spanningRows

          protected Exporter.SpanningRows spanningRows

    - #### spanningFooterRows

          protected Exporter.SpanningRows spanningFooterRows

    - #### filename

          protected java.lang.String filename

    - #### pageOnly

          protected boolean pageOnly

    - #### excludeColumns

          protected int[] excludeColumns

    - #### encodingType

          protected java.lang.String encodingType

    - #### preProcessor

          protected javax.el.MethodExpression preProcessor

    - #### postProcessor

          protected javax.el.MethodExpression postProcessor

    - #### includeHeaders

          protected boolean includeHeaders

    - #### includeFooters

          protected boolean includeFooters

    - #### selectedRowsOnly

          protected boolean selectedRowsOnly

    - #### userColumnOrder

          protected boolean userColumnOrder

    - #### expandedOnly

          protected boolean expandedOnly

    - #### pdfFont

          protected java.lang.String pdfFont

  - ### Constructor Detail

    - #### Exporter

          public Exporter()

  - ### Method Detail

    - #### setUp

          public void setUp(DataExporter component,
                            DataTable table)

    - #### export

          public abstract java.lang.String export(javax.faces.context.FacesContext facesContext,
                                                  DataExporter component,
                                                  DataTable table)
                                           throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### getColumnsToExport

          protected java.util.List<javax.faces.component.UIColumn> getColumnsToExport(javax.faces.component.UIData table,
                                                                                      int[] excludedColumns)

    - #### getColumnGroupHeader

          protected ColumnGroup getColumnGroupHeader(javax.faces.component.UIData table)

    - #### getColumnGroupFooter

          protected ColumnGroup getColumnGroupFooter(javax.faces.component.UIData table)

    - #### hasColumnFooter

          protected boolean hasColumnFooter(java.util.List<javax.faces.component.UIColumn> columns)

    - #### getRows

          protected java.util.List<Row> getRows(ColumnGroup columnGroup)

    - #### getRows

          protected java.util.List<Row> getRows(ColumnGroup columnGroup,
                                                boolean includeAll)

    - #### determineHeaderColumnOrdering

          protected void determineHeaderColumnOrdering(java.util.List<Row> rows,
                                                       DataTable table)

    - #### getRowColumnsToExport

          protected java.util.List<javax.faces.component.UIColumn> getRowColumnsToExport(Row row,
                                                                                         javax.faces.component.UIData table,
                                                                                         int[] excludedColumns)

    - #### getFooterRowColumnsToExport

          protected java.util.List<javax.faces.component.UIColumn> getFooterRowColumnsToExport(Row row,
                                                                                               javax.faces.component.UIData table,
                                                                                               int[] excludedColumns)

    - #### shouldExcludeFromExport

          protected boolean shouldExcludeFromExport(javax.faces.component.UIComponent component)

    - #### resolveExcludedColumnIndexes

          protected int[] resolveExcludedColumnIndexes(java.lang.String columnsToExclude)

    - #### exportValue

          protected java.lang.String exportValue(javax.faces.context.FacesContext context,
                                                 javax.faces.component.UIComponent component)

    - #### exportConditionalRowValues

          protected void exportConditionalRowValues(java.lang.StringBuilder builder,
                                                    Row row)

    - #### exportChildRowValues

          protected void exportChildRowValues(javax.faces.context.FacesContext context,
                                              TreeDataModel rootModel,
                                              RowStateMap rowStateMap,
                                              DataTable table,
                                              java.lang.String rootIndex,
                                              java.lang.StringBuilder builder)

    - #### registerResource

          protected java.lang.String registerResource(byte[] bytes,
                                                      java.lang.String filename,
                                                      java.lang.String contentType)

Copyright 2025 ICEsoft Technologies Canada, Corp. All Rights Reserved.